#include-once

; StructStack (SS)

; Bastelt aus SingleLinkedLists einen Stack

; Anwendung:
; - Definiere einen Stack via SSCreate('int;int') mit bis zu 4 verschiedenen Datentypen
; - Push via SSPush($Stack, 'a', 'b')
; - Pop via $ARRAY = SSPop($Stack). Obacht bei einem Underflow wird kein Array zurckgegeben. Errorcheck via IsArray ntig

#include 'DllStructProtected.au3'

#cs
#include <Array.au3>
Global $Stack = SSCreate('char;char[4];float;int')

SSPush($Stack, 'a', 'Test' , 5.112   , 255 ) ; alles passt
SSPush($Stack, 65 , ''     , 123     , 128 ) ; vorne wird eine 65 = 'A' gepushed
SSPush($Stack, 5.4, 'Hallo', SSCreate, 9999) ; wieder falsche Datentypen

Local $a = SSPop($Stack)
Local $b = SSPop($Stack)
Local $c = SSPop($Stack)

_ArrayDisplay($a)
_ArrayDisplay($b)
_ArrayDisplay($c)
#ce

Func SSCreate($sStruct = 'int')
	Local $aStack = [$sStruct, UBound(StringSplit($sStruct, ';', 2)), Null]
	Return $aStack
EndFunc   ;==>SSCreate

Func SSPush2int(ByRef $vStack, $1, $2)
	Local $LL = DllStructCreateProtected('ptr;int;int')
	DllStructSetData($LL, 1, DllStructGetPtr($vStack[2]))
	DllStructSetData($LL, 2, $1)
	DllStructSetData($LL, 3, $2)
	$vStack[2] = $LL
EndFunc

Func SSPop2int(ByRef $vStack)
	Local $aRet = [DllStructGetData($vStack[2], 2), DllStructGetData($vStack[2], 3)]
	Local $ptr = DllStructGetData($vStack[2], 1)
	DllStructDelete($vStack[2])
	$vStack[2] = ($ptr <> 0) ? DllStructCreate('ptr;int;int', $ptr) : Null
	Return $aRet
EndFunc   ;==>SSPop

Func SSPush(ByRef $vStack, $1, $2 = 0, $3 = 0, $4 = 0)
	Local $LL = DllStructCreateProtected('ptr;' & $vStack[0]), $aParam = [$1, $2, $3, $4]
	DllStructSetData($LL, 1, DllStructGetPtr($vStack[2]))
	For $i = 1 To @NumParams - 1 Step 1
		DllStructSetData($LL, $i + 1, $aParam[$i - 1])
	Next
	$vStack[2] = $LL
EndFunc   ;==>SSPush

Func SSPop(ByRef $vStack)
	If Not IsDllStruct($vStack[2]) Then Return SetError(1, 0, 'underflow')
	Local $aRet[$vStack[1]]
	For $i = 1 To $vStack[1] Step 1
		$aRet[$i - 1] = DllStructGetData($vStack[2], $i + 1)
	Next
	Local $ptr = DllStructGetData($vStack[2], 1)
	DllStructDelete($vStack[2])
	$vStack[2] = ($ptr <> 0) ? DllStructCreate('ptr;' & $vStack[0], $ptr) : Null
	Return $aRet
EndFunc   ;==>SSPop